package tp.mesClasses;






/**
 * La classe List reprsente une liste simplement chane
 * @author jub
 *
 * @param <X> le type des lments de la liste
 */
public class Liste<X>{
	/**
	 * La liste est reprsente par sa tte, la tte n'est jamais nulle et ne contient pas de donnes significatives
	 */
	private Cellule<X> tete;
	/**
	 * Construit une liste vide.
	 */
	public Liste() {
		this.tete = new Cellule<X>(); 
	}

	/**
	 * Permet de savoir si la liste est vide. 
	 * @return true si la liste est vide et false sinon.
	 */
	public boolean estVide()
	{
		return this.tete.getSuivant() == null;
	}

	/**
	 * Renvoie la dernire valeur
	 * @return la dernire valeur
	 */
	public X getDernier()
	{
		return this.getVal(this.getTaille()-1);
	}

	/**
	 * Renvoie la premire valeur
	 * @return la premire valeur
	 */
	public X getPremier()
	{
		return this.getVal(0);
	}

	/**
	 * Renvoie la taille de la liste, zro si elle est vide
	 * @return la taille de la liste
	 */
	public int getTaille()
	{
		int res = 0;
		Cellule<X> curseur = this.tete.getSuivant();
		while (curseur !=null)
		{
			curseur = curseur.getSuivant();
			res++;
		}
		return res;
	}


	/**
	 * Renvoie la valeur  une position choisie
	 * @param pos la position
	 * @return la valeur de la cellule
	 */
	public X getVal(int pos)
	{
		X res = null;

		if (pos >=0 && pos < this.getTaille())
		{
			int i = 0;
			Cellule<X> curseur = this.tete.getSuivant();
			for(i=0; i < pos; i++)
			{
				curseur = curseur.getSuivant();
			}
			res = curseur.getValeur();
		}
		return res;
	}

	/**
	 * Permet de rejouter une veleur en queue
	 * @param val la valeur  rajouter
	 */
	public void insereQueue(X val)
	{
		this.insertionPosition(val, this.getTaille()-1);
	}

	/**
	 * Insere une valeur en tte
	 * @param val la valeur  inserer
	 */
	public void insereTete(X val)
	{
		this.insertionPosition(val, 0);
	}

	/**
	 * Insre une valeur  une position choisie
	 * @param val la valeur
	 * @param pos la position
	 */
	public void insertionPosition(X val, int pos)
	{
		int l = this.getTaille();
		if (pos <= l)
			{
			Cellule<X> curseur = this.tete;
			for (int i=0; i < pos; i++ )
				curseur = curseur.getSuivant();
			
			Cellule<X> cellule = new Cellule<X>();
			cellule.setValeur(val);
			cellule.setSuivant(curseur.getSuivant());
			curseur.setSuivant(cellule);
			}
	}

	/**
	 * Modifie une valeur  une position connue
	 * @param val la valeur
	 * @param pos la position
	 */
	public void setVal(X val,int pos)
	{
		int l = this.getTaille();
		if (pos < l)
		{
			Cellule<X> curseur = this.tete.getSuivant();
			for (int i=0; i < pos; i++ )
				curseur = curseur.getSuivant();
			curseur.setValeur(val);
		}
	}

	/**
	 * Supprime une valeur  une position choisie
	 * @param pos la position
	 */
	public void suppressionPosition(int pos)
	{
		int l = this.getTaille();
		if (pos < l)
		{
			Cellule<X> curseur = this.tete;
			for(int i=0; i < pos ; i++)
				curseur = curseur.getSuivant();
			curseur.setSuivant(curseur.getSuivant().getSuivant());
		}
	}

	/**
	 * Supprime la dernire valeur
	 */
	public void suppressionQueue()
	{
		this.suppressionPosition(this.getTaille()-1);
	}

	/**
	 * Supprime la premire valeur
	 */
	public void suppressionTete()
	{
		this.suppressionPosition(0);
	}
	@Override
	public String toString() {
		String res="";
		if (!estVide())
		
			for (int i=0; i<getTaille(); i++)
				res = res +"["+getVal(i)+"]";
				
	 return res;
		
			
	}
}
