package tp.mesClasses;

/**
 * @author jub
 *Une Pile est une structure de donnes LIFO (Last In First Out).
 *Ici la Pile est non borne 
 * @param <X>
 */
public class Pile<X> {
	/**
	 * La Pile est caractrise par une Liste
	 */
	private Liste<X> liste;
	/**
	 * Permet de construire une Pile vide 
	 */
	public Pile(){
		this.liste = new Liste<X>();
	}
	/**
	 * Permet de savoir si la pile est vide
	 * @return true si la pile est vide et false sinon
	 */
	public boolean estVide(){
		return this.liste.estVide();
	}
	
	/**
	 * Permet d'empiler une valeur
	 * @param val la valeur empile
	 */
	public void push(X val){
		this.liste.insereTete(val);
	}
	
	/**
	 * Permet de dpiler une valeur
	 * @return la valeur dpile.
	 */
	public X pop(){
		X res = this.liste.getPremier();
		this.liste.suppressionTete();
		return res;
	}
	@Override
	public String toString() {
		
		return this.liste.toString()+"<-";
	}
	
}
