package tp.mesClasses;

import java.util.Collections;
import java.util.Vector;

/**
 * Cette classe dfinit l'objet <code>PromoPersonne</code>.  Une promotion compose de personnes.
 * @author jub
 * 
 */
public class PromoPersonne {
	/**
	 * La promotion, un vecteur de personnes
	 */
	private Vector<PersonnePlus> promo;
	
	/**
	 * Construit une promotion vide
	 */
	public PromoPersonne()
	{
		this.promo = new Vector<PersonnePlus>();
	}
	
	/**
	 * Ajoute une personne  la promotion 
	 * @param p la personne  ajouter
	 */
	public void ajout(PersonnePlus p)
	{
		this.promo.add(p);
	}
	
	/**
	 * Supprime la premire personne correspondante de la promo
	 * @param p la personne  supprimer
	 */
	public void suppression(PersonnePlus p)
	{
		this.promo.remove(p);
	}
	
	/**
	 * Permet de connatre la taille de la promotion
	 * @return le nombre d'lves.
	 */
	public int nbEleve()
	{
		return this.promo.size();
	}
	
	/**
	 * Trie une pormotion
	 * @return la promotion tri
	 */
	public Vector<PersonnePlus> getPromo()
	{
		Vector<PersonnePlus> personnes = new Vector<PersonnePlus>(this.promo);
		Collections.sort(personnes);
		return personnes;
	}
}
