package tp.mesClasses.recursivite;

public class ArbreB<X> {
	private X valeur;

	private ArbreB<X> filsG;

	private ArbreB<X> filsD;

	public ArbreB(ArbreB<X> filsG, X valeur, ArbreB<X> filsD)
	{
		this.valeur = valeur;
		this.filsG = filsG;
		this.filsD = filsD;
	}

	public ArbreB(X valeur)
	{
		this(null,valeur,null);
	}

	public boolean estFeuille(){
		return this.filsD == null && this.filsG ==null;
	}

	public boolean estNoeud(){
		return !estFeuille();
	}

	public ArbreB<X> getFilsD() {
		return filsD;
	}

	public ArbreB<X> getFilsG() {
		return filsG;
	}

	public X getValeur() {
		return valeur;
	}
	public int hauteur()
	{
		int res =0;
		if (estNoeud())
		{
			if (this.filsG !=null && this.filsD!=null)
				res = 1 + Math.max(filsG.hauteur(), filsD.hauteur());
			else
				if (this.filsG == null)
					res = 1 + filsD.hauteur();
				else
					res = 1 + filsG.hauteur();
		}
		return res;
	}
	public String parcoursPostordre()
	{
		String res="";
		if (this.filsG !=null)
			res = res + this.filsG.parcoursPostordre();
		if (this.filsD !=null)
			res = res + this.filsD.parcoursPostordre();
		res = res + this.getValeur().toString();
		return res;
	}

	public String parcoursPreordre()
	{
		String res=this.getValeur().toString();
		if (this.filsG!=null)
			res = res + this.filsG.parcoursPreordre();
		if (this.filsD!=null)
			res = res + this.filsD.parcoursPreordre();
		return res;
	}

	public void setFilsD(ArbreB<X> filsD) {
		this.filsD = filsD;
	}
	
	public void setFilsG(ArbreB<X> filsG) {
		this.filsG = filsG;
	}

	public void setValeur(X valeur) {
		this.valeur = valeur;
	}

	public int taille()
	{
		int res = 1;
		if (this.filsG!=null && this.filsD!=null)
				res = res + filsG.taille() + filsD.taille();
			else
			{	
			if (this.filsG!=null)
				res = res + filsG.taille();
			if (this.filsD!=null)
				res = res + filsD.taille();
			}
		return res;
	}
	
	
	@Override
	public String toString() {
		return "Arbre [valeur=" + valeur + ", filsG=" + filsG + ", filsD="
		+ filsD + "]";
	}


}
