package tp.mesClasses.recursivite;

import tp.mesClasses.Cellule;




/**
 * La classe List reprsente une liste simplement chane
 * @author jub
 *
 * @param <X> le type des lments de la liste
 */
public class Liste<X>{
	/**
	 * La liste est reprsente par sa tte, la tte n'est jamais nulle et ne contient pas de donnes significatives
	 */
	private Cellule<X> tete;

	/**
	 * Construit une liste vide,  savoir une liste constitue uniquement de la tte.
	 */
	public Liste() {
		this.tete = new Cellule<X>(); 
	}



	private X car()
	{
		X res = null;
		if (!estVide())
			res = this.tete.getSuivant().getValeur();
		return res;
	}

	private Liste<X> cdr()
	{
		Liste<X> res = new Liste<X>();
		if (!estVide())
			res.tete = tete.getSuivant();
		return res;
	}

	public boolean estVide()
	{
		return this.tete.getSuivant() == null;
	}

	public X getDernier()
	{
		return this.getVal(this.getTaille()-1);
	}

	public X getPremier()
	{
		return this.getVal(0);
	}

	public int getTaille()
	{
		int res;
		if (estVide())
			res = 0;
		else
			res = 1 + this.cdr().getTaille();
		return res;
	}


	public X getVal(int pos)
	{
		X res = null;
		if (pos < this.getTaille() && pos>=0)
			if (pos==0)
				res = this.tete.getSuivant().getValeur();
			else
				res = this.cdr().getVal(pos-1);
		return res;
	}

	public void insereQueue(X val)
	{
		this.insertionPosition(val, this.getTaille()-1);
	}

	public void insereTete(X val)
	{
		this.insertionPosition(val, 0);
	}

	public void insertionPosition(X val, int pos)
	{
		if (pos <= this.getTaille())

			if (pos == 0)
			{

				Cellule<X> cellule = new Cellule<X>();
				cellule.setValeur(val);
				cellule.setSuivant(this.tete.getSuivant());
				this.tete.setSuivant(cellule);
			}
			else
				this.cdr().insertionPosition(val, pos-1);

	}
	
	public void setVal(X val,int pos)
	{
		if (pos < this.getTaille())
			if (pos==0)
				this.tete.getSuivant().setValeur(val);
			else
				this.cdr().setVal(val, pos-1);
		
	}
	
	public void suppressionPosition(int pos)
	{
		if (pos < this.getTaille() && pos >=0)
		{
			if (pos == 0)
				{
					this.tete = this.tete.getSuivant();
					//this.tete.setValeur(null);
				}
			else
			{
					Liste<X> l= this.cdr();
					l.suppressionPosition(pos-1);
					this.tete.getSuivant().setSuivant(l.tete.getSuivant());
			}
		}
	}
	
	public void suppressionQueue()
	{
		this.suppressionPosition(this.getTaille()-1);
	}
	
	public void suppressionTete()
	{
		this.suppressionPosition(0);
	}
	@Override
	public String toString() {
		// TODO Auto-generated method stub
		return tete.toString();
	}
}
